JAVASE基础 Item -- 异常处理Exception

一、异常概述

异常:异常就是Java程序在运行过程中出现的错误。
异常由来:问题也是现实生活中一个具体事务,也可以通过java 的类的形式进行描述,并封装成对象。其实就是Java对不正常情况进行描述后的对象体现。
我们见过的异常,角标越界异常,空指针异常

1.1 异常分类

这里写图片描述

package cn.itcast_01;

/*
 * 异常:程序出现了不正常的情况。
 * 
 * 举例:今天天气很好,班长出去旅游。骑着自行车,去山里面呼吸新鲜空气。
 *      问题1:山路塌陷了,班长及时停住了,但是过不去了。严重的问题。   Error
 *      问题2:班长出门推自行车,发现气没了,把气吹起来。出发前就应该检查的问题。 Exception
 *      问题3:班长骑着车在山路上惬意的行驶着,山路两边是有小石子的,中间是平坦的水泥路。 RuntimeException
 *          一直在平坦的水泥路上行驶是没有任何问题的,但是呢,他偏偏喜欢骑到小石子上,结果爆胎了。旅游的过程中出现的问题。
 *          no zuo no die。
 * 
 * 程序的异常:Throwable
 *      1,编译时异常
            除了RuntimeException及其子类,Exception中所有的子类都是,这种异常必须要处理,要不编译通不过
        2,运行是异常
            RuntimeException及其子类都是,这种异常不用处理,编译会通过,不过这样的程序会有安全隐患,遇到这种异常是需要改代码的
        3,严重错误问题
            用Error进行描述,这个问题发生后,一般不编写针对代码进行处理,而是要对程序进行修正.通常都是由虚拟机抛出的问题

 * 如何程序出现了问题,我们没有做任何处理,最终jvm会做出默认的处理。
 * 把异常的名称,原因及出现的问题等信息输出在控制台。
 * 同时会结束程序。
 */
public class ExceptionDemo {
    public static void main(String[] args) {
        //第一阶段
        int a = 10;
        // int b = 2;
        int b = 0;
        System.out.println(a / b);

        //第二阶段
        System.out.println("over");
    }
}

1.2 异常处理方案

try…catch…finally
throws

package cn.itcast_02;

/*
 * 我们自己如何处理异常呢?
 * A:try...catch...finally
 * B:throws 抛出
 * 
 * try...catch...finally的处理格式:
 *      try {
 *          可能出现问题的代码;
 *      }catch(异常名 变量) {
 *          针对问题的处理;
 *      }finally {
 *          释放资源;
 *      }
 * 
 * 变形格式:
 *      try {
 *          可能出现问题的代码;
 *      }catch(异常名 变量) {
 *          针对问题的处理;
 *      }
 * 
 * 注意:
 *      A:try里面的代码越少越好
 *      B:catch里面必须有内容,哪怕是给出一个简单的提示
 */
public class ExceptionDemo {
    public static void main(String[] args) {
        // 第一阶段
        int a = 10;
        // int b = 2;
        int b = 0;

        try {
            System.out.println(a / b);
        } catch (ArithmeticException ae) {
            System.out.println("除数不能为0");
        }

        // 第二阶段
        System.out.println("over");
    }
}

二、try…catch处理方式

2.1 一个异常的情况(见上例)

2.2 多个异常的情况(平级情况以及存在上下级的情况)

package cn.itcast_02;

/*
 * A:一个异常
 * B:二个异常的处理
 *      a:每一个写一个try...catch
 *      b:写一个try,多个catch
 *          try{
 *              ...
 *          }catch(异常类名 变量名) {
 *              ...
 *          }
 *          catch(异常类名 变量名) {
 *              ...
 *          }
 *          ...
 * 
 *          注意事项:
 *              1:能明确的尽量明确,不要用大的来处理。
 *              2:平级关系的异常谁前谁后无所谓,如果出现了子父关系,父必须在后面。
 * 
 * 注意:
 *      一旦try里面出了问题,就会在这里把问题给抛出去,然后和catch里面的问题进行匹配,
 *      一旦有匹配的,就执行catch里面的处理,然后结束了try...catch
 *      继续执行后面的语句。
 */
public class ExceptionDemo2 {
    public static void main(String[] args) {
        // method1();

        // method2();

        // method3();

        method4();
    }

    public static void method4() {
        int a = 10;
        int b = 0;
        int[] arr = { 1, 2, 3 };

        // 爷爷在最后
        try {
            System.out.println(a / b);
            System.out.println(arr[3]);
            System.out.println("这里出现了一个异常,你不太清楚是谁,该怎么办呢?");
        } catch (ArithmeticException e) {
            System.out.println("除数不能为0");
        } catch (ArrayIndexOutOfBoundsException e) {
            System.out.println("你访问了不该的访问的索引");
        } catch (Exception e) {
            System.out.println("出问题了");
        }

        // 爷爷在前面是不可以的
        // try {
        // System.out.println(a / b);
        // System.out.println(arr[3]);
        // System.out.println("这里出现了一个异常,你不太清楚是谁,该怎么办呢?");
        // } catch (Exception e) {
        // System.out.println("出问题了");
        // } catch (ArithmeticException e) {
        // System.out.println("除数不能为0");
        // } catch (ArrayIndexOutOfBoundsException e) {
        // System.out.println("你访问了不该的访问的索引");
        // }

        System.out.println("over");
    }

    // 两个异常的处理
    public static void method3() {
        int a = 10;
        int b = 0;
        int[] arr = { 1, 2, 3 };

        try {
            System.out.println(arr[3]);
            System.out.println(a / b);
            // System.out.println(arr[3]);
        } catch (ArithmeticException e) {
            System.out.println("除数不能为0");
        } catch (ArrayIndexOutOfBoundsException e) {
            System.out.println("你访问了不该的访问的索引");
        }

        System.out.println("over");
    }

    // 两个异常
    public static void method2() {
        int a = 10;
        int b = 0;
        try {
            System.out.println(a / b);
        } catch (ArithmeticException e) {
            System.out.println("除数不能为0");
        }

        int[] arr = { 1, 2, 3 };
        try {
            System.out.println(arr[3]);
        } catch (ArrayIndexOutOfBoundsException e) {
            System.out.println("你访问了不该的访问的索引");
        }

        System.out.println("over");
    }

    // 一个异常
    public static void method1() {
        // 第一阶段
        int a = 10;
        // int b = 2;
        int b = 0;

        try {
            System.out.println(a / b);
        } catch (ArithmeticException ae) {
            System.out.println("除数不能为0");
        }

        // 第二阶段
        System.out.println("over");
    }
}

2.3 JDK7的新特性及注意事项

package cn.itcast_02;

/*
 * JDK7出现了一个新的异常处理方案:
 *      try{
 * 
 *      }catch(异常名1 | 异常名2 | ...  变量 ) {
 *          ...
 *      }
 * 
 *      注意:这个方法虽然简洁,但是也不够好。
 *          A:处理方式是一致的。(实际开发中,好多时候可能就是针对同类型的问题,给出同一个处理)
 *          B:多个异常间必须是平级关系。
 */
public class ExceptionDemo3 {
    public static void main(String[] args) {
        method();
    }

    public static void method() {
        int a = 10;
        int b = 0;
        int[] arr = { 1, 2, 3 };

        // try {
        // System.out.println(a / b);
        // System.out.println(arr[3]);
        // System.out.println("这里出现了一个异常,你不太清楚是谁,该怎么办呢?");
        // } catch (ArithmeticException e) {
        // System.out.println("除数不能为0");
        // } catch (ArrayIndexOutOfBoundsException e) {
        // System.out.println("你访问了不该的访问的索引");
        // } catch (Exception e) {
        // System.out.println("出问题了");
        // }

        // JDK7的处理方案
        try {
            System.out.println(a / b);
            System.out.println(arr[3]);
        } catch (ArithmeticException | ArrayIndexOutOfBoundsException e) {
            System.out.println("出问题了");
        }

        System.out.println("over");
    }

}

2.4 编译时异常和运行时异常的区别

Java中的异常被分为两大类:编译时异常和运行时异常。所有的RuntimeException类及其子类的实例被称为运行时异常,其他的异常就是编译时异常

  • 编译时异常
    Java程序必须显示处理,否则程序就会发生错误,无法通过编译
  • 运行时异常
    无需显示处理,也可以和编译时异常一样处理

2.5 Throwable中的方法

  • getMessage()
    获取异常信息,返回字符串。
  • toString()
    获取异常类名和异常信息,返回字符串。
  • printStackTrace()
    获取异常类名和异常信息,以及异常出现在程序中的位置。返回值void。
  • printStackTrace(PrintStream s)
    通常用该方法将异常内容保存在日志文件中,以便查阅。
package cn.itcast_04;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

/*
 * 在try里面发现问题后,jvm会帮我们生成一个异常对象,然后把这个对象抛出,和catch里面的类进行匹配。
 * 如果该对象是某个类型的,就会执行该catch里面的处理信息。
 * 
 * 异常中要了解的几个方法:
 * public String getMessage():异常的消息字符串      
 * public String toString():返回异常的简单信息描述
 *      此对象的类的 name(全路径名)
 *      ": "(冒号和一个空格) 
 *      调用此对象 getLocalizedMessage()方法的结果 (默认返回的是getMessage()的内容)
 * printStackTrace() 获取异常类名和异常信息,以及异常出现在程序中的位置。返回值void。把信息输出在控制台。
 */
public class ExceptionDemo {
    public static void main(String[] args) {
        String s = "2014-11-20";
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        try {
            Date d = sdf.parse(s); // 创建了一个ParseException对象,然后抛出去,和catch里面进行匹配
            System.out.println(d);
        } catch (ParseException e) { // ParseException e = new ParseException();
            // ParseException
            // e.printStackTrace();

            // getMessage()
            // System.out.println(e.getMessage());
            // Unparseable date: "2014-11-20"

            // toString()
            // System.out.println(e.toString());
            // java.text.ParseException: Unparseable date: "2014-11-20"

            e.printStackTrace();
            //跳转到某个指定的页面(index.html)
        }

        System.out.println("over");
    }
}

三 、 throws

定义功能方法时,需要把出现的问题暴露出来让调用者去处理。那么就通过throws在方法上标识。

package cn.itcast_05;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

/*
 * 有些时候,我们是可以对异常进行处理的,但是又有些时候,我们根本就没有权限去处理某个异常。
 * 或者说,我处理不了,我就不处理了。
 * 为了解决出错问题,Java针对这种情况,就提供了另一种处理方案:抛出。
 * 
 * 格式:
 *      throws 异常类名
 *      注意:这个格式必须跟在方法的括号后面。
 * 
 * 注意:
 *      尽量不要在main方法上抛出异常。   
 * 
 * 小结:
 *      编译期异常抛出,将来调用者必须处理。
 *      运行期异常抛出,将来调用可以不用处理。
 */
public class ExceptionDemo {
    public static void main(String[] args) {
        System.out.println("今天天气很好");
        try {
            method();
        } catch (ParseException e) {
            e.printStackTrace();
        }
        System.out.println("但是就是不该有雾霾");

        method2();
    }

    // 运行期异常的抛出
    public static void method2() throws ArithmeticException {
        int a = 10;
        int b = 0;
        System.out.println(a / b);
    }

    // 编译期异常的抛出
    // 在方法声明上抛出,是为了告诉调用者,你注意了,我有问题。
    public static void method() throws ParseException {
        String s = "2014-11-20";
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");
        Date d = sdf.parse(s);
        System.out.println(d);
    }
}

3.1 throws和throw的区别

  • throws
    用在方法声明后面,跟的是异常类名
    可以跟多个异常类名,用逗号隔开
    表示抛出异常,由该方法的调用者来处理
    throws表示出现异常的一种可能性,并不一定会发生这些异常
  • throw
    用在方法体内,跟的是异常对象名
    只能抛出一个异常对象名
    表示抛出异常,由方法体内的语句处理
    throw则是抛出了异常,执行throw则一定抛出了某种异常
package cn.itcast_06;

/*
 * throw:如果出现了异常情况,我们可以把该异常抛出,这个时候的抛出的应该是异常的对象。
 * 
 * throws和throw的区别(面试题)
    throws
        用在方法声明后面,跟的是异常类名
        可以跟多个异常类名,用逗号隔开
        表示抛出异常,由该方法的调用者来处理
        throws表示出现异常的一种可能性,并不一定会发生这些异常
    throw
        用在方法体内,跟的是异常对象名
        只能抛出一个异常对象名
        表示抛出异常,由方法体内的语句处理
        throw则是抛出了异常,执行throw则一定抛出了某种异常
 */
public class ExceptionDemo {
    public static void main(String[] args) {
        // method();

        try {
            method2();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    public static void method() {
        int a = 10;
        int b = 0;
        if (b == 0) {
            throw new ArithmeticException();
        } else {
            System.out.println(a / b);
        }
    }

    public static void method2() throws Exception {
        int a = 10;
        int b = 0;
        if (b == 0) {
            throw new Exception();
        } else {
            System.out.println(a / b);
        }
    }
}

3.2 如何处理异常

原则:如果该功能内部可以将问题处理,用try,如果处理不了,交由调用者处理,这是用throws

  • 区别:
    后续程序需要继续运行就try
    后续程序不需要继续运行就throws
  • 举例:
    感冒了就自己吃点药就好了,try
    吃了好几天药都没好结果得了H7N9,那就的得throws到医院
    如果医院没有特效药就变成Error了

四、finally的特点作用

4.1 finally的特点

被finally控制的语句体一定会执行
特殊情况:在执行到finally之前jvm退出了(比如System.exit(0))

4.2 finally的特点

被finally控制的语句体一定会执行
特殊情况:在执行到finally之前jvm退出了(比如System.exit(0))

package cn.itcast_07;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

/*
 * finally:被finally控制的语句体一定会执行
 * 注意:如果在执行到finally之前jvm退出了,就不能执行了。
 * 
 * A:格式
 *      try...catch...finally...
 * B:用于释放资源,在IO流操作和数据库操作中会见到
 */
public class FinallyDemo {
    public static void main(String[] args) {
        String s = "2014-11-20";
        SimpleDateFormat sdf = new SimpleDateFormat("yyyy-MM-dd HH:mm:ss");

        Date d = null;
        try {
            // System.out.println(10 / 0);
            d = sdf.parse(s);
        } catch (ParseException e) {
            e.printStackTrace();
            //System.exit(0);
        } finally {
            System.out.println("这里的代码是可以执行的");
        }

        System.out.println(d);
    }
}

4.3 final,finally和finalize的区别

如果catch里面有return语句,请问finally的代码还会执行吗?如果会,请问是在return前还是return后。

package cn.itcast_07;

/*
 * 面试题:
 * 1:final,finally和finalize的区别
 * final:最终的意思,可以修饰类,成员变量,成员方法
 *      修饰类,类不能被继承
 *      修饰变量,变量是常量
 *      修饰方法,方法不能被重写
 * finally:是异常处理的一部分,用于释放资源。
 *      一般来说,代码肯定会执行,特殊情况:在执行到finally之前jvm退出了
 * finalize:是Object类的一个方法,用于垃圾回收
 * 
 * 2:如果catch里面有return语句,请问finally里面的代码还会执行吗?
 *   如果会,请问是在return前,还是return后。
 *     会。前。
 * 
 *   准确的说,应该是在中间。
 * 
 * 3:try...catch...finally的格式变形
 *      A:try...catch...finally
 *      B:try...catch
 *      C:try...catch...catch...
 *      D:try...catch...catch...finally
 *      E:try...finally
 *          这种做法的目前是为了释放资源。
 */
public class FinallyDemo2 {
    public static void main(String[] args) {
        System.out.println(getInt());
    }

    public static  int getInt() {
        int a = 10;
        try {
            System.out.println(a / 0);
            a = 20;
        } catch (ArithmeticException e) {
            a = 30;
            return a;
            /*
             * return a在程序执行到这一步的时候,这里不是return a而是return 30;这个返回路径就形成了。
             * 但是呢,它发现后面还有finally,所以继续执行finally的内容,a=40
             * 再次回到以前的返回路径,继续走return 30;
             */
        } finally {
            a = 40;
            //return a;//如果这样结果就是40了。
        }
         return a;
    }
}

五、 自定义异常

考试成绩必须在0-100之间
很明显java没有对应的异常,需要我们自己来做一个异常

  • 自定义异常
    继承自Exception
    继承自RuntimeException

1、自定义一个 MyException

package cn.itcast_08;

/*
 * java不可能对所有的情况都考虑到,所以,在实际的开发中,我们可能需要自己定义异常。
 * 而我们自己随意的写一个类,是不能作为异常类来看的,要想你的类是一个异常类,
 * 就必须继承自Exception或者RuntimeException
 * 
 * 两种方式:
 * A:继承Exception
 * B:继承RuntimeException
 */
public class MyException extends Exception {
    public MyException() {
    }

    public MyException(String message) {
        super(message);
    }
}

// public class MyException extends RuntimeException {
//
// }

2、编写老师打分的程序

package cn.itcast_08;

public class Teacher {
    public void check(int score) throws MyException {
        if (score > 100 || score < 0) {
            throw new MyException("分数必须在0-100之间");
        } else {
            System.out.println("分数没有问题");
        }
    }

    // 针对MyException继承自RuntimeException
    // public void check(int score) {
    // if (score > 100 || score < 0) {
    // throw new MyException();
    // } else {
    // System.out.println("分数没有问题");
    // }
    // }
}

3、 编写学生成绩类

package cn.itcast_08;

import java.util.Scanner;

/*
 * 自定义异常测试类
 */
public class StudentDemo {
    public static void main(String[] args) {
        Scanner sc = new Scanner(System.in);
        System.out.println("请输入学生成绩:");
        int score = sc.nextInt();

        Teacher t = new Teacher();
        try {
            t.check(score);
        } catch (MyException e) {
            e.printStackTrace();
        }
    }
}

异常注意事项

  • 子类重写父类方法时,子类的方法必须抛出相同的异常或父类异常的子类。(父亲坏了,儿子不能比父亲更坏)

  • 如果父类抛出了多个异常,子类重写父类时,只能抛出相同的异常或者是他的子集,子类不能抛出父类没有的异常

  • 如果被重写的方法没有异常抛出,那么子类的方法绝对不可以抛出异常,如果子类方法内有异常发生,那么子类只能try,不能throws

package cn.itcast_09;

import java.text.ParseException;
import java.text.SimpleDateFormat;
import java.util.Date;

/*
 * 异常注意事项:
 * A:子类重写父类方法时,子类的方法必须抛出相同的异常或父类异常的子类。(父亲坏了,儿子不能比父亲更坏)
 * B:如果父类抛出了多个异常,子类重写父类时,只能抛出相同的异常或者是他的子集,子类不能抛出父类没有的异常
 * C:如果被重写的方法没有异常抛出,那么子类的方法绝对不可以抛出异常,如果子类方法内有异常发生,那么子类只能try,不能throws
 */
public class ExceptionDemo {

}

class Fu {
    public void show() throws Exception {
    }

    public void method() {
    }
}

class Zi extends Fu {
    @Override
    public void show() throws ArithmeticException {

    }

    @Override
    public void method() {
        // String s = "2014-11-20";
        // SimpleDateFormat sdf = new SimpleDateFormat();
        // Date d = sdf.parse(s);
        // System.out.println(d);
    }
}
已标记关键词 清除标记
©️2020 CSDN 皮肤主题: 猿与汪的秘密 设计师:白松林 返回首页